PoolableConnection (Apache Tomcat 9.0.37 API Documentation)

org.apache.tomcat.dbcp.dbcp2

## Class PoolableConnection

- java.lang.Object
- - org.apache.tomcat.dbcp.dbcp2.AbandonedTrace
  - - org.apache.tomcat.dbcp.dbcp2.DelegatingConnection<Connection>
    - - org.apache.tomcat.dbcp.dbcp2.PoolableConnection

- All Implemented Interfaces:
    AutoCloseable, Connection, Wrapper, PoolableConnectionMXBean, TrackedUse
  Direct Known Subclasses:
    PoolableManagedConnection

      public class PoolableConnection
      extends DelegatingConnection<Connection>
      implements PoolableConnectionMXBean

  A delegating connection that, rather than closing the underlying connection, returns itself to an `ObjectPool` when closed.
  Since:
    2.0

- - ### Field Summary

    - ### Fields inherited from interface java.sql.Connection

      `TRANSACTION_NONE, TRANSACTION_READ_COMMITTED, TRANSACTION_READ_UNCOMMITTED, TRANSACTION_REPEATABLE_READ, TRANSACTION_SERIALIZABLE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PoolableConnection(Connection conn, ObjectPool<PoolableConnection> pool, ObjectName jmxName)`
    `PoolableConnection(Connection conn, ObjectPool<PoolableConnection> pool, ObjectName jmxObjectName, Collection<String> disconnectSqlCodes, boolean fastFailValidation)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Returns me to my pool.
    `Collection<String>` | `getDisconnectionSqlCodes()`
    `String` | `getToString()` Expose the `DelegatingConnection.toString()` method via a bean getter so it can be read as a property via JMX.
    `protected void` | `handleException(SQLException e)`
    `boolean` | `isClosed()` This method should not be used by a client to determine whether or not a connection should be return to the connection pool (by calling `close()`).
    `boolean` | `isFastFailValidation()`
    `protected void` | `passivate()`
    `void` | `reallyClose()` Actually close my underlying `Connection`.
    `void` | `validate(String sql, int timeoutSeconds)` Validates the connection, using the following algorithm: If `fastFailValidation` (constructor argument) is `true` and this connection has previously thrown a fatal disconnection exception, a `SQLException` is thrown.

    - ### Methods inherited from class org.apache.tomcat.dbcp.dbcp2.DelegatingConnection

      `abort, activate, checkOpen, clearCachedState, clearWarnings, closeInternal, commit, createArrayOf, createBlob, createClob, createNClob, createSQLXML, createStatement, createStatement, createStatement, createStruct, getAutoCommit, getCacheState, getCatalog, getClientInfo, getClientInfo, getDefaultQueryTimeout, getDelegate, getDelegateInternal, getHoldability, getInnermostDelegate, getInnermostDelegateInternal, getMetaData, getNetworkTimeout, getSchema, getTransactionIsolation, getTypeMap, getWarnings, handleExceptionNoThrow, innermostDelegateEquals, isClosedInternal, isReadOnly, isValid, isWrapperFor, nativeSQL, prepareCall, prepareCall, prepareCall, prepareStatement, prepareStatement, prepareStatement, prepareStatement, prepareStatement, prepareStatement, releaseSavepoint, rollback, rollback, setAutoCommit, setCacheState, setCatalog, setClientInfo, setClientInfo, setClosedInternal, setDefaultQueryTimeout, setDelegate, setHoldability, setNetworkTimeout, setReadOnly, setSavepoint, setSavepoint, setSchema, setTransactionIsolation, setTypeMap, toString, unwrap`

    - ### Methods inherited from class org.apache.tomcat.dbcp.dbcp2.AbandonedTrace

      `addTrace, clearTrace, getLastUsed, getTrace, removeThisTrace, removeTrace, setLastUsed, setLastUsed`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tomcat.dbcp.dbcp2.PoolableConnectionMXBean

      `clearCachedState, clearWarnings, getAutoCommit, getCacheState, getCatalog, getHoldability, getSchema, getTransactionIsolation, isReadOnly, setAutoCommit, setCacheState, setCatalog, setHoldability, setReadOnly, setSchema, setTransactionIsolation`

- - ### Constructor Detail

    - #### PoolableConnection

          public PoolableConnection(Connection conn,
                                    ObjectPool<PoolableConnection> pool,
                                    ObjectName jmxObjectName,
                                    Collection<String> disconnectSqlCodes,
                                    boolean fastFailValidation)

      Parameters:
        `conn` - my underlying connection
        `pool` - the pool to which I should return when closed
        `jmxObjectName` - JMX name
        `disconnectSqlCodes` - SQL_STATE codes considered fatal disconnection errors
        `fastFailValidation` - true means fatal disconnection errors cause subsequent validations to fail immediately (no attempt to run query or isValid)

    - #### PoolableConnection

          public PoolableConnection(Connection conn,
                                    ObjectPool<PoolableConnection> pool,
                                    ObjectName jmxName)

      Parameters:
        `conn` - my underlying connection
        `pool` - the pool to which I should return when closed
        `jmxName` - JMX name

  - ### Method Detail

    - #### passivate

          protected void passivate()
                            throws SQLException

      Overrides:
        `passivate` in class `DelegatingConnection<Connection>`
      Throws:
        `SQLException`

    - #### isClosed

          public boolean isClosed()
                           throws SQLException

      This method should not be used by a client to determine whether or not a connection should be return to the connection pool (by calling `close()`). Clients should always attempt to return a connection to the pool once it is no longer required.

      Specified by:
        `isClosed` in interface `Connection`
      Specified by:
        `isClosed` in interface `PoolableConnectionMXBean`
      Overrides:
        `isClosed` in class `DelegatingConnection<Connection>`
      Throws:
        `SQLException`

    - #### close

          public void close()
                     throws SQLException

      Returns me to my pool.
      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in interface `Connection`
      Specified by:
        `close` in interface `PoolableConnectionMXBean`
      Overrides:
        `close` in class `DelegatingConnection<Connection>`
      Throws:
        `SQLException`

    - #### reallyClose

          public void reallyClose()
                           throws SQLException

      Actually close my underlying `Connection`.
      Specified by:
        `reallyClose` in interface `PoolableConnectionMXBean`
      Throws:
        `SQLException`

    - #### getToString

          public String getToString()

      Expose the `DelegatingConnection.toString()` method via a bean getter so it can be read as a property via JMX.
      Specified by:
        `getToString` in interface `PoolableConnectionMXBean`

    - #### validate

          public void validate(String sql,
                               int timeoutSeconds)
                        throws SQLException

      Validates the connection, using the following algorithm:
      1. If `fastFailValidation` (constructor argument) is `true` and this connection has previously thrown a fatal disconnection exception, a `SQLException` is thrown.
      2. If `sql` is null, the driver's #`isValid(timeout)` is called. If it returns `false`, `SQLException` is thrown; otherwise, this method returns successfully.
      3. If `sql` is not null, it is executed as a query and if the resulting `ResultSet` contains at least one row, this method returns successfully. If not, `SQLException` is thrown.
      Parameters:
        `sql` - The validation SQL query.
        `timeoutSeconds` - The validation timeout in seconds.
      Throws:
        `SQLException` - Thrown when validation fails or an SQLException occurs during validation

    - #### handleException

          protected void handleException(SQLException e)
                                  throws SQLException

      Overrides:
        `handleException` in class `DelegatingConnection<Connection>`
      Throws:
        `SQLException`

    - #### getDisconnectionSqlCodes

          public Collection<String> getDisconnectionSqlCodes()

      Returns:
        The disconnection SQL codes.
      Since:
        2.6.0

    - #### isFastFailValidation

          public boolean isFastFailValidation()

      Returns:
        Whether to fail-fast.
      Since:
        2.6.0

Copyright © 2000-2020 Apache Software Foundation. All Rights Reserved.